﻿Option Explicit On
Option Strict On
Imports System.Runtime.InteropServices

Public Class formMain
    '
    Protected Overrides Sub WndProc(ByRef myMessage As Message)
        '
        Dim myCOPYDATASTRUCT As COPYDATASTRUCT
        Dim myObject As Object
        '
        If myMessage.Msg = WM_COPYDATA Then
            '
            myObject = Marshal.PtrToStructure(myMessage.LParam, GetType(COPYDATASTRUCT))
            myCOPYDATASTRUCT = DirectCast(myObject, COPYDATASTRUCT)
            stringSTRINGRETURNEDFROMSTICKIES = Marshal.PtrToStringAnsi(myCOPYDATASTRUCT.lpData)
            stringSTRINGRETURNEDFROMSTICKIES = Microsoft.VisualBasic.Left(stringSTRINGRETURNEDFROMSTICKIES, _
                                                                          myCOPYDATASTRUCT.cbData)
            '
        End If
        '
        MyBase.WndProc(myMessage)
        '
    End Sub

    Private Sub formMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        '
        Dim stringMessageText As String
        Dim integerAnswer As Integer
        '
        intptrWINDOWHANDLEOFTHISAPP = Me.Handle
        '
        Me.textboxReport.Text = ""
        '
        stringMessageText = "Make it a habit to ALWAYS keep backup copies of essential files " & _
                            "before trying new applications." & _
                            vbCrLf & vbCrLf & _
                            "Since this happens to be a new application, would you like to terminate " & _
                            "it now in order to make backup copies of your Stickies files?"
        integerAnswer = MsgBox(stringMessageText, _
                               CType(vbQuestion + vbYesNo, MsgBoxStyle), _
                               "VB2008 Calling The Stickies API")
        '
        If integerAnswer = vbYes Then
            '
            Me.Close()
            '
        End If
        '
    End Sub

    Private Sub commandbuttonObtainStickiesWindowHandle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles commandbuttonObtainStickiesWindowHandle.Click
        '
        ' Obtain the handle of the Main Window of Stickies
        '
        intptrWINDOWHANDLEOFSTICKIES = FindWindow(vbNullString, "ZhornSoftwareStickiesMain")
        Me.textboxReport.Text = "Stickies Window Handle: " & CStr(intptrWINDOWHANDLEOFSTICKIES)
        '
        If CInt(intptrWINDOWHANDLEOFSTICKIES) = 0 Then
            '
            ' Stickies is not running
            '
            Me.textboxReport.Text = Me.textboxReport.Text & vbCrLf & "Stickies is NOT running"
            Me.commandbuttonPingStickies.Enabled = False
            Me.commandbuttonOpenStickiesManageDialogue.Enabled = False
            Me.commandbuttonGetDesktopList.Enabled = False
        Else
            '
            ' Stickies is running
            '
            Me.textboxReport.Text = Me.textboxReport.Text & vbCrLf & "Stickies IS running"
            Me.commandbuttonPingStickies.Enabled = True
            Me.commandbuttonOpenStickiesManageDialogue.Enabled = True
            Me.commandbuttonGetDesktopList.Enabled = True
        End If
        '
    End Sub

    Private Sub commandbuttonOpenStickiesManageDialogue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles commandbuttonOpenStickiesManageDialogue.Click
        '
        Dim myCOPYDATASTRUCT As COPYDATASTRUCT
        Dim integerFunctionResult As Integer
        '
        ' Setup the string for opening the Manage Dialogue of Stickies
        '
        stringSTRINGSENTTOSTICKIES = "api do manage open"
        '
        Me.textboxReport.Text = Me.textboxReport.Text & vbCrLf & stringSTRINGSENTTOSTICKIES
        Me.textboxReport.SelectionStart = Len(Me.textboxReport.Text)
        '
        ' Prepare the string and send it to Stickies
        '
        myCOPYDATASTRUCT.dwData = 1
        myCOPYDATASTRUCT.cbData = stringSTRINGSENTTOSTICKIES.Length + 1
        myCOPYDATASTRUCT.lpData = Marshal.StringToHGlobalAnsi(stringSTRINGSENTTOSTICKIES)
        '
        integerFunctionResult = SendMessage(intptrWINDOWHANDLEOFSTICKIES, _
                                            WM_COPYDATA, _
                                            intptrWINDOWHANDLEOFTHISAPP, _
                                            myCOPYDATASTRUCT)
        '
        Marshal.FreeHGlobal(myCOPYDATASTRUCT.lpData)
        '
        ' Display the string returned by the API.
        '
        Me.textboxReport.Text = Me.textboxReport.Text & vbCrLf & stringSTRINGRETURNEDFROMSTICKIES
        Me.textboxReport.SelectionStart = Me.textboxReport.Text.Length
        Me.textboxReport.ScrollToCaret()
        '
    End Sub

    Private Sub commandbuttonPingStickies_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles commandbuttonPingStickies.Click
        '
        Dim myCOPYDATASTRUCT As COPYDATASTRUCT
        Dim integerFunctionResult As Integer
        '
        ' Setup the string for Pinging Stickies
        '
        stringSTRINGSENTTOSTICKIES = "api do ping"
        '
        Me.textboxReport.Text = Me.textboxReport.Text & vbCrLf & stringSTRINGSENTTOSTICKIES
        Me.textboxReport.SelectionStart = Len(Me.textboxReport.Text)
        '
        ' Prepare the string and send it to Stickies
        '
        myCOPYDATASTRUCT.dwData = 1
        myCOPYDATASTRUCT.cbData = stringSTRINGSENTTOSTICKIES.Length + 1
        myCOPYDATASTRUCT.lpData = Marshal.StringToHGlobalAnsi(stringSTRINGSENTTOSTICKIES)
        '
        integerFunctionResult = SendMessage(intptrWINDOWHANDLEOFSTICKIES, _
                                            WM_COPYDATA, _
                                            intptrWINDOWHANDLEOFTHISAPP, _
                                            myCOPYDATASTRUCT)
        '
        Marshal.FreeHGlobal(myCOPYDATASTRUCT.lpData)
        '
        ' Display the string returned by the API.
        '
        Me.textboxReport.Text = Me.textboxReport.Text & vbCrLf & stringSTRINGRETURNEDFROMSTICKIES
        Me.textboxReport.SelectionStart = Me.textboxReport.Text.Length
        Me.textboxReport.ScrollToCaret()
        '
    End Sub

    Private Sub commandbuttonGetDesktopList_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles commandbuttonGetDesktopList.Click
        '
        Dim myCOPYDATASTRUCT As COPYDATASTRUCT
        Dim integerFunctionResult As Integer
        '
        ' Setup the string for getting a list of the desktop stickies
        '
        stringSTRINGSENTTOSTICKIES = "api get list desktop"
        '
        Me.textboxReport.Text = Me.textboxReport.Text & vbCrLf & stringSTRINGSENTTOSTICKIES
        Me.textboxReport.SelectionStart = Me.textboxReport.Text.Length
        '
        ' Prepare the string and send it to Stickies
        '
        myCOPYDATASTRUCT.dwData = 1
        myCOPYDATASTRUCT.cbData = stringSTRINGSENTTOSTICKIES.Length + 1
        myCOPYDATASTRUCT.lpData = Marshal.StringToHGlobalAnsi(stringSTRINGSENTTOSTICKIES)
        '
        integerFunctionResult = SendMessage(intptrWINDOWHANDLEOFSTICKIES, _
                                            WM_COPYDATA, _
                                            intptrWINDOWHANDLEOFTHISAPP, _
                                            myCOPYDATASTRUCT)
        '
        Marshal.FreeHGlobal(myCOPYDATASTRUCT.lpData)
        '
        ' Display the string returned by the API.
        '
        Me.textboxReport.Text = Me.textboxReport.Text & vbCrLf & stringSTRINGRETURNEDFROMSTICKIES
        Me.textboxReport.SelectionStart = Me.textboxReport.Text.Length
        Me.textboxReport.ScrollToCaret()
        '
    End Sub
    '
End Class
